Attribute VB_Name = "intersection"
Global Const EPSILON = 0.000001

'---------------------------------------------------------------------------
' Point en 3D
'---------------------------------------------------------------------------
Public Type Point3
    X As Double
    Y As Double
    Z As Double
End Type

'---------------------------------------------------------------------------
' Triangle en 3D
'---------------------------------------------------------------------------
Public Type Triangle3
   S(2) As Point3
End Type
    
'Produit vectoriel
Function VecProd(P1 As Point3, P2 As Point3) As Point3
Dim P4 As Point3

 P4.X = (P1.Y * P2.Z) - (P1.Z * P2.Y)
 P4.Y = (P1.Z * P2.X) - (P1.X * P2.Z)
 P4.Z = (P1.X * P2.Y) - (P1.Y * P2.X)
 VecProd = P4
 
End Function

'Produit Scalaire
Function Dot(p As Point3, q As Point3) As Double
    Dot = p.X * q.X + p.Y * q.Y + p.Z * q.Z
End Function

'Ajout de vecteur
Function VecAdd(P1 As Point3, P2 As Point3, Optional f As Double = 1) As Point3
 Dim P3 As Point3
 P3.X = P1.X + f * P2.X
 P3.Y = P1.Y + f * P2.Y
 P3.Z = P1.Z + f * P2.Z
 VecAdd = P3
End Function

' Soustraction de vecteur
Function VecSub(P1 As Point3, P2 As Point3) As Point3
 VecSub.X = P1.X - P2.X
 VecSub.Y = P1.Y - P2.Y
 VecSub.Z = P1.Z - P2.Z
End Function

'----------------------------------------------------------------------------
' Calcul L'intersection d'un triangle et d'un vecteur
'----------------------------------------------------------------------------
Function Intersect_Triangle_Vecteur(orig As Point3, dir As Point3, Trig As Triangle3) As Double

   Dim edge1   As Point3
   Dim edge2   As Point3
   Dim tvec    As Point3
   Dim pvec    As Point3
   Dim qvec    As Point3
   Dim det     As Double
   Dim inv_det As Double
   
   Dim T As Double
   Dim U As Double
   Dim V As Double
   

   ' Calcul des deux vecteurs reprsentant les arrtes partant du point 0 du triangle
   edge1 = VecSub(Trig.S(1), Trig.S(0))
   edge2 = VecSub(Trig.S(2), Trig.S(0))

   ' Debut par calcul du dterminant aussi utilis pour calculer le paramtre U
  pvec = VecProd(dir, edge2)

   ' Si le dterminant est dans le mme plan alors les segment et le triangle sont dans le mme plan
   det = Dot(edge1, pvec)

   If (det > -EPSILON And det < EPSILON) Then
           GoTo Fin
    End If
    
   inv_det = 1 / det

   ' Calcule distance entre le sommet 0  l'origine du vecteur
   tvec = VecSub(orig, Trig.S(0))

   ' Calcule le parametre U et test les limites
   U = Dot(tvec, pvec) * inv_det
   If U < 0 Or U > 1 Then
      GoTo Fin
    End If
    
   ' Preparation pour tester le parametre V
   qvec = VecProd(tvec, edge1)

   ' Calcule le parametre  V et test les limites
   V = Dot(dir, qvec) * inv_det
   If V < 0 Or (U + V) > 1 Then
      GoTo Fin
   End If
    
   ' Calcule T, le vecteur intersecte le  triangle
   T = Dot(edge2, qvec) * inv_det


Fin:
    Intersect_Triangle_Vecteur = T
End Function



